<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading();">

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table class="table table-bordered table-striped table-hover" id="table-users">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>13528</td>
          <td>John</td>
          <td>Doe</td>
          <td>23</td>
          <td>...</td>
        </tr>
        <tr>
          <td>23528</td>
          <td>Mary</td>
          <td>Moe</td>
          <td>42</td>
          <td>...</td>
        </tr>
        <tr>
          <td>13348</td>
          <td>July</td>
          <td>Dooley</td>
          <td>54</td>
          <td>...</td>
        </tr>
      </tbody>
    </table>
  </div>
  ​
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    function onPageLoading() {
      var vUserObj = JSON.parse(gJsonUser);
      loadDataToTable(vUserObj.users);
      addEventListenerAction();
    }
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnDetailClick(paramUserDetail) {
      var vUserId = $(paramUserDetail).data('userId');
      var vFirstname = $(paramUserDetail).data('firstname');
      console.log(vUserId);
      console.log(vFirstname);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function loadDataToTable(paramUsers) {
      var vTableUser = $("#table-users");
      $("#table-users tbody").empty();
      for (let index = 0; index < paramUsers.length; index++) {
        const element = paramUsers[index];
        var newRow = $("<tr>").appendTo(vTableUser)
                    .append($("<td>",{html: element.userId}));
        $("<td>",{html: element.firstname}).appendTo(newRow);
        $("<td>",{html: element.lastname}).appendTo(newRow);
        $("<td>",{html: element.age}).appendTo(newRow);
        var bActionCel = $('<td>').appendTo(newRow);
        
        var bActionButton = $('<button>', {html: 'Chi tiết'}).addClass('btn btn-primary user-detail')
          .data("userId",element.userId)
          .data("firstname",element.firstname)
          .data("lastname",element.lastname)
          .data("age",element.age)
          .appendTo(bActionCel);
      }
    }
    function addEventListenerAction() {
      $('.user-detail').on('click',function(){
        onBtnDetailClick(this); //
      })
    }
  </script>
</body>

</html>
​